Similarity (Lucene 2.4.1 API)
Keywords: org.apache.lucene.search.Similarity class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class Similarity

    java.lang.Object
      org.apache.lucene.search.Similarity

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DefaultSimilarity, SimilarityDelegator

    public abstract class Similarity

extends Object
implements Serializable

Expert: Scoring API.

Subclasses implement search scoring.

The score of query `q` for document `d` correlates to the cosine-distance or dot-product between document and query vectors in a Vector Space Model (VSM) of Information Retrieval. A document whose vector is closer to the query vector in that model is scored higher. The score is computed as follows:

score(q,d) = coord(q,d) · queryNorm(q) · | ∑ | ( tf(t in d) · idf(t)2 · t.getBoost() · norm(t,d) )
| t in q |

where

1. tf(t in d) correlates to the term's frequency, defined as the number of times term t appears in the currently scored document d. Documents that have more occurrences of a given term receive a higher score. The default computation for tf(t in d) in `DefaultSimilarity` is:

   `tf(t in d)` = | frequency½

2. idf(t) stands for Inverse Document Frequency. This value correlates to the inverse of docFreq (the number of documents in which the term t appears). This means rarer terms give higher contribution to the total score. The default computation for idf(t) in `DefaultSimilarity` is:

   `idf(t)` = | 1 + log ( |
   numDocs
   –––––––––
   docFreq+1
   | )

3. coord(q,d) is a score factor based on how many of the query terms are found in the specified document. Typically, a document that contains more of the query's terms will receive a higher score than another document with fewer query terms. This is a search time factor computed in `coord(q,d)` by the Similarity in effect at search time.
4. queryNorm(q) is a normalizing factor used to make scores between queries comparable. This factor does not affect document ranking (since all ranked documents are multiplied by the same factor), but rather just attempts to make scores from different queries (or even different indexes) comparable. This is a search time factor computed by the Similarity in effect at search time. The default computation in `DefaultSimilarity` is:

   queryNorm(q) = `queryNorm(sumOfSquaredWeights)` = |
   1
   ––––––––––––––
   sumOfSquaredWeights½

   The sum of squared weights (of the query terms) is computed by the query `Weight` object. For example, a `boolean query` computes this value as:

   `sumOfSquaredWeights` = `q.getBoost()` 2 · | ∑ | ( idf(t) · t.getBoost() ) 2
   | t in q |

5. t.getBoost() is a search time boost of term t in the query q as specified in the query text (see query syntax), or as set by application calls to `setBoost()`. Notice that there is really no direct API for accessing a boost of one term in a multi term query, but rather multi terms are represented in a query as multi `TermQuery` objects, and so the boost of a term in the query is accessible by calling the sub-query `getBoost()`.
6. norm(t,d) encapsulates a few (indexing time) boost and length factors:
   - Document boost - set by calling `doc.setBoost()` before adding the document to the index.
   - Field boost - set by calling `field.setBoost()` before adding the field to a document.
   - `lengthNorm(field)` - computed when the document is added to the index in accordance with the number of tokens of this field in the document, so that shorter fields contribute more to the score. LengthNorm is computed by the Similarity class in effect at indexing.

   When a document is added to the index, all the above factors are multiplied. If the document has multiple fields with the same name, all their boosts are multiplied together:

   norm(t,d) = `doc.getBoost()` · `lengthNorm(field)` · | ∏ | `f.getBoost`()
   | field f in d named as t |

   However the resulted norm value is `encoded` as a single byte before being stored. At search time, the norm byte value is read from the index `directory` and `decoded` back to a float norm value. This encoding/decoding, while reducing index size, comes with the price of precision loss - it is not guaranteed that decode(encode(x)) = x. For instance, decode(encode(0.89)) = 0.75. Also notice that search time is too late to modify this norm part of scoring, e.g. by using a different `Similarity` for search.

See Also:
  `setDefault(Similarity)`, `IndexWriter.setSimilarity(Similarity)`, `Searcher.setSimilarity(Similarity)`, Serialized Form

Constructor Summary
`Similarity()`

Method Summary
`abstract float` | `coord(int overlap, int maxOverlap)` Computes a score factor based on the fraction of all query terms that a document contains.
`static float` | `decodeNorm(byte b)` Decodes a normalization factor stored in an index.
`static byte` | `encodeNorm(float f)` Encodes a normalization factor for storage in an index.
`static Similarity` | `getDefault()` Return the default Similarity implementation used by indexing and search code.
`static float[]` | `getNormDecoder()` Returns a table for decoding normalization bytes.
`float` | `idf(Collection terms, Searcher searcher)` Computes a score factor for a phrase.
`abstract float` | `idf(int docFreq, int numDocs)` Computes a score factor based on a term's document frequency (the number of documents which contain the term).
`float` | `idf(Term term, Searcher searcher)` Computes a score factor for a simple term.
`abstract float` | `lengthNorm(String fieldName, int numTokens)` Computes the normalization value for a field given the total number of terms contained in a field.
`abstract float` | `queryNorm(float sumOfSquaredWeights)` Computes the normalization value for a query given the sum of the squared weights of each of the query terms.
`float` | `scorePayload(String fieldName, byte[] payload, int offset, int length)` Calculate a scoring factor based on the data in the payload.
`static void` | `setDefault(Similarity similarity)` Set the default Similarity implementation used by indexing and search code.
`abstract float` | `sloppyFreq(int distance)` Computes the amount of a sloppy phrase match, based on an edit distance.
`abstract float` | `tf(float freq)` Computes a score factor based on a term or phrase's frequency in a document.
`float` | `tf(int freq)` Computes a score factor based on a term or phrase's frequency in a document.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Similarity

    public Similarity()

Method Detail

### setDefault

    public static void setDefault(Similarity similarity)

  Set the default Similarity implementation used by indexing and search code.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### getDefault

    public static Similarity getDefault()

  Return the default Similarity implementation used by indexing and search code.

  This is initially an instance of `DefaultSimilarity`.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### decodeNorm

    public static float decodeNorm(byte b)

  Decodes a normalization factor stored in an index.

  See Also:
    `encodeNorm(float)`

### getNormDecoder

    public static float[] getNormDecoder()

  Returns a table for decoding normalization bytes.

  See Also:
    `encodeNorm(float)`

### lengthNorm

    public abstract float lengthNorm(String fieldName,
                                     int numTokens)

  Computes the normalization value for a field given the total number of terms contained in a field. These values, together with field boosts, are stored in an index and multipled into scores for hits on each field by the search code.

  Matches in longer fields are less precise, so implementations of this method usually return smaller values when `numTokens` is large, and larger values when `numTokens` is small.

  That these values are computed under `IndexWriter.addDocument(org.apache.lucene.document.Document)` and stored then using `encodeNorm(float)`. Thus they have limited precision, and documents must be re-indexed if this method is altered.

  Parameters:
    `fieldName` - the name of the field
    `numTokens` - the total number of tokens contained in fields named fieldName of doc.
  Returns:
    a normalization factor for hits on this field of this document
  See Also:
    `AbstractField.setBoost(float)`

### queryNorm

    public abstract float queryNorm(float sumOfSquaredWeights)

  Computes the normalization value for a query given the sum of the squared weights of each of the query terms. This value is then multipled into the weight of each query term.

  This does not affect ranking, but rather just attempts to make scores from different queries comparable.

  Parameters:
    `sumOfSquaredWeights` - the sum of the squares of query term weights
  Returns:
    a normalization factor for query weights

### encodeNorm

    public static byte encodeNorm(float f)

  Encodes a normalization factor for storage in an index.

  The encoding uses a three-bit mantissa, a five-bit exponent, and the zero-exponent point at 15, thus representing values from around 7x10^9 to 2x10^-9 with about one significant decimal digit of accuracy. Zero is also represented. Negative numbers are rounded up to zero. Values too large to represent are rounded down to the largest representable value. Positive values too small to represent are rounded up to the smallest positive representable value.

  See Also:
    `AbstractField.setBoost(float)`, `SmallFloat`

### tf

    public float tf(int freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(Term, Searcher)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  The default implementation calls `tf(float)`.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### sloppyFreq

    public abstract float sloppyFreq(int distance)

  Computes the amount of a sloppy phrase match, based on an edit distance. This value is summed for each sloppy phrase match in a document to form the frequency that is passed to `tf(float)`.

  A phrase match with a small edit distance to a document passage more closely matches the document, so implementations of this method usually return larger values when the edit distance is small and smaller values when it is large.

  Parameters:
    `distance` - the edit distance of this sloppy phrase match
  Returns:
    the frequency increment for this match
  See Also:
    `PhraseQuery.setSlop(int)`

### tf

    public abstract float tf(float freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(Term, Searcher)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### idf

    public float idf(Term term,
                     Searcher searcher)
              throws IOException

  Computes a score factor for a simple term.

  The default implementation is:

         return idf(searcher.docFreq(term), searcher.maxDoc());

  Note that `Searcher.maxDoc()` is used instead of `IndexReader.numDocs()` because it is proportional to `Searcher.docFreq(Term)` , i.e., when one is inaccurate, so is the other, and in the same direction.

  Parameters:
    `term` - the term in question
    `searcher` - the document collection being searched
  Returns:
    a score factor for the term
  Throws:
    `IOException`

### idf

    public float idf(Collection terms,
                     Searcher searcher)
              throws IOException

  Computes a score factor for a phrase.

  The default implementation sums the `idf(Term,Searcher)` factor for each term in the phrase.

  Parameters:
    `terms` - the terms in the phrase
    `searcher` - the document collection being searched
  Returns:
    a score factor for the phrase
  Throws:
    `IOException`

### idf

    public abstract float idf(int docFreq,
                              int numDocs)

  Computes a score factor based on a term's document frequency (the number of documents which contain the term). This value is multiplied by the `tf(int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms that occur in fewer documents are better indicators of topic, so implementations of this method usually return larger values for rare terms, and smaller values for common terms.

  Parameters:
    `docFreq` - the number of documents which contain the term
    `numDocs` - the total number of documents in the collection
  Returns:
    a score factor based on the term's document frequency

### coord

    public abstract float coord(int overlap,
                                int maxOverlap)

  Computes a score factor based on the fraction of all query terms that a document contains. This value is multiplied into scores.

  The presence of a large portion of the query terms indicates a better match with the query, so implementations of this method usually return larger values when the ratio between these parameters is large and smaller values when the ratio between them is small.

  Parameters:
    `overlap` - the number of query terms matched in the document
    `maxOverlap` - the total number of terms in the query
  Returns:
    a score factor based on term overlap with the query

### scorePayload

    public float scorePayload(String fieldName,
                              byte[] payload,
                              int offset,
                              int length)

  Calculate a scoring factor based on the data in the payload. Overriding implementations are responsible for interpreting what is in the payload. Lucene makes no assumptions about what is in the byte array.

  The default implementation returns 1.

  Parameters:
    `fieldName` - The fieldName of the term this payload belongs to
    `payload` - The payload byte array to be scored
    `offset` - The offset into the payload array
    `length` - The length in the array
  Returns:
    An implementation dependent float to be used as a scoring factor

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.